int rectSize = 10;
int[][] langtonActuel, langtonSuivant;
Regles regles;

int[][] loop=
  {
  {0, 2, 2, 2, 2, 2, 2, 2, 2, 0, 0, 0, 0, 0},
  {2, 1, 7, 0, 1, 4, 0, 1, 4, 2, 0, 0, 0, 0},
  {2, 0, 2, 2, 2, 2, 2, 2, 0, 2, 0, 0, 0, 0},
  {2, 7, 2, 0, 0, 0, 0, 2, 1, 2, 0, 0, 0, 0},
  {2, 1, 2, 0, 0, 0, 0, 2, 1, 2, 0, 0, 0, 0},
  {2, 0, 2, 0, 0, 0, 0, 2, 1, 2, 0, 0, 0, 0},
  {2, 7, 2, 0, 0, 0, 0, 2, 1, 2, 0, 0, 0, 0},
  {2, 1, 2, 2, 2, 2, 2, 2, 1, 2, 2, 2, 2, 2},
  {2, 0, 7, 1, 0, 7, 1, 0, 7, 1, 1, 1, 1, 1},
  {0, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2},
};


void setup()
{

  size(900, 800);
  frameRate(15);

  int sizeX = width/rectSize;
  int sizeY = height/rectSize;
  langtonActuel = new int[sizeY][sizeX];
  langtonSuivant = new int[sizeY][sizeX];
  regles = new Regles("langton.table");

  for (int i=0; i<langtonActuel.length; i++)
  {
    for (int j=0; j< langtonActuel[i].length; j++)
      langtonActuel[i][j]=0;
  }

  int offsetX=sizeX/2;
  int offsetY = sizeY/2;
  for (int i=0; i<loop.length; i++)
  {
    for (int j=0; j< loop[i].length; j++)
      langtonActuel[offsetY-loop.length/2+i][offsetX-loop.length/2+j]=loop[i][j];
  }
}

void draw()
{
  update();

  for (int i=0; i < langtonActuel.length; i++)
  {
    for (int j=0; j<langtonActuel[i].length; j++)
    {
      fill(recupereCouleur(langtonActuel[i][j]));
      rect(j*rectSize, i*rectSize, rectSize, rectSize);
    }
  }
}

int recupereCouleur(int etat)
{
  if (etat == 1)
    return #0035FF; 
  if (etat == 2)
    return #FF0000;
  if (etat == 7)
    return #FFFFFF;
  if (etat == 4 || etat == 0)
    return #000000;
  
  return #FFFFFF;
}

void update()
{
  for (int i=1; i < langtonActuel.length-1; i++)
  {
    for (int j=1; j<langtonActuel[i].length-1; j++)
    {
      int valeurCase = regles.correspond(langtonActuel[i][j], langtonActuel[i-1][j], langtonActuel[i][j+1], langtonActuel[i+1][j], langtonActuel[i][j-1]);
      if(valeurCase != -1)
        langtonSuivant[i][j] = valeurCase;
       
      
    }
  }

  // Mise à jour de la case
  for (int i=0; i < langtonActuel.length; i++)
  {
    for (int j=0; j<langtonActuel[i].length; j++)
    {
      langtonActuel[i][j] = langtonSuivant[i][j];
    }
  }
}
